﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinListView;

namespace _121675
{
    public partial class Form1 : Form
    {
        string rootLokation = "L:\\Data";
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DirectoryInfo[] dirs = new DirectoryInfo(rootLokation).GetDirectories();
            
            foreach (DirectoryInfo dir in dirs)
            {
                
                ultraNavigationBar1.RootLocation.Locations.Add(dir.FullName, dir.Name);
            }
            
        }

        private void ultraNavigationBar1_InitializeLocations(object sender, Infragistics.Win.Misc.UltraWinNavigationBar.InitializeLocationsEventArgs e)
        {
            
            // Populate an array of DirectoryInfos with the
            // subdirectories of the parent location's path.
            DirectoryInfo[] dirs =
                new DirectoryInfo
                ((e.ParentLocation.Equals(ultraNavigationBar1.RootLocation)? rootLokation:e.ParentLocation.Key)
                    + "\\").GetDirectories();

            // Loop through each subdirectory...
            foreach (DirectoryInfo dir in dirs)
            {
                // ...add a new location to WinNavigationBar.
                // The subdirectory's full path will be the key 
                // and the name will be the Text.
                e.ParentLocation.Locations.Add(dir.FullName, dir.Name);
            }
           

        }

        private void LoadFilesAndFolders(string path)
        {
            
            // Populate an array of DirectoryInfos with the
            // subdirectories of the selected location's path.
            DirectoryInfo[] dirs =
                new DirectoryInfo
                (path + "\\").GetDirectories();

            // Get the files associated with the selected location.
            FileInfo[] files =
                new DirectoryInfo
                (path + "\\").GetFiles();

            // Clear the previous location’s items from WinListView.
            this.ultraListView1.Items.Clear();

            UltraListViewItem item = null;

            // Populate WinListView with folders and files.
            foreach (DirectoryInfo dir in dirs)
            {
                item = this.ultraListView1.Items.Add(dir.FullName, dir.Name);
                item.Tag = dir;

                // At this point, you can assign an image
                // to the folder items with a line of code
                // similar to the following...
                //item.Appearance.Image = this.imageListLarge.Images[0];
            }

            foreach (FileInfo file in files)
            {
                item = this.ultraListView1.Items.Add(file.FullName, file.Name);
                item.Tag = file;
            }
        }

        private void ultraNavigationBar1_SelectedLocationChanged(object sender, Infragistics.Win.Misc.UltraWinNavigationBar.SelectedLocationChangedEventArgs e)
        {
            this.LoadFilesAndFolders(e.SelectedLocation.Key);
        }

        private void ultraListView1_ItemDoubleClick(object sender, Infragistics.Win.UltraWinListView.ItemDoubleClickEventArgs e)
        {
            if (e.Item.Tag is DirectoryInfo)
            {
                this.ultraNavigationBar1.NavigateTo(e.Item.Key, true);
            }
            else if (e.Item.Tag is FileInfo)
            {
                System.Diagnostics.Process.Start(e.Item.Key);
            }

        }

        

       

    }
}
